Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# ReMutexDirect Class Reference

This class implements a standard reMutex by making direct calls to the underlying implementation layer. More...

Inheritance diagram for ReMutexDirect:

List of all members.

## Public Member Functions
| acquire ()
| Grabs the reMutex if it is available.
| acquire (Thread current_thread)
| This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.
| clearName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | debugIsLocked ()
| Returns true if the current thread has locked the ReMutex, false otherwise.
| elevateLock ()
| This method increments the lock count, assuming the calling thread already holds the lock.
string | getName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | hasName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
| output (ostream out)
| This method is declared virtual in MutexDebug, but non-virtual in ReMutexDirect.
| release ()
| Releases the reMutex.
| setName (string name)
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | tryAcquire ()
| Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.
bool | tryAcquire (Thread current_thread)
| Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

## Detailed Description

This class implements a standard reMutex by making direct calls to the underlying implementation layer.

It doesn't perform any debugging operations.

## Member Function Documentation

acquire | ( |  | ) |

Grabs the reMutex if it is available.

If it is not available, blocks until it becomes available, then grabs it. In either case, the function does not return until the reMutex is held; you should then call unlock().

This method is considered const so that you can lock and unlock const reMutexes, mainly to allow thread-safe access to otherwise const data.

Also see ReMutexHolder.

acquire | ( | Thread | current_thread | ) |

This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.

clearName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool debugIsLocked | ( |  | ) |

Returns true if the current thread has locked the ReMutex, false otherwise.

This method is only intended for use in debugging, hence the method name; in the ReMutexDirect case, it always returns true, since there's not a reliable way to determine this otherwise.

elevateLock | ( |  | ) |

This method increments the lock count, assuming the calling thread already holds the lock.

After this call, release() will need to be called one additional time to release the lock.

This method really performs the same function as acquire(), but it offers a potential (slight) performance benefit when the calling thread knows that it already holds the lock. It is an error to call this when the calling thread does not hold the lock.

string getName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool hasName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

output | ( | ostream | out | ) |

This method is declared virtual in MutexDebug, but non-virtual in ReMutexDirect.

release | ( |  | ) |

Releases the reMutex.

It is an error to call this if the reMutex was not already locked.

This method is considered const so that you can lock and unlock const reMutexes, mainly to allow thread-safe access to otherwise const data.

setName | ( | string | name | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool tryAcquire | ( |  | ) |

Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

bool tryAcquire | ( | Thread | current_thread | ) |

Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties